import {Collection} from '../../../lib/src/collection/Collection.ts'
import {DependencyRequirement} from '../type/DependencyRequirement.ts'

export default abstract class AbstractFactory {
    protected constructor(
        protected token: any
    ) {}

    abstract produce(dependencies: any[], parameters: any[]): any
    abstract match(something: any): boolean
    abstract get_dependency_keys(): Collection<DependencyRequirement>
}
