import Factory from './Factory.ts'
import Instantiable from "../type/Instantiable.ts";

export default class NamedFactory extends Factory {
    constructor(
        protected name: string,
        protected token: Instantiable<any>,
    ) {
        super(token)
    }

    match(something: any) {
        return something === this.name
    }
}
