export type StaticClass<T, T2> = Function & {prototype: T} & T2

export function isStaticClass<T, T2>(something: any): something is StaticClass<T, T2> {
    return typeof something === 'function' && typeof something.prototype !== 'undefined'
}
