export default abstract class Cache {
    public abstract async fetch(key: string): Promise<any>;
    public abstract async put(key: string, value: string): Promise<void>;
    public abstract async has(key: string): Promise<boolean>;
    public abstract async drop(key: string): Promise<void>;
}
